Rcpp::sourceCpp('tools/support/maxVelocity.cpp')
Rcpp::sourceCpp('tools/support/negativeStarts.cpp')
Rcpp::sourceCpp('tools/support/positiveStarts.cpp')

findQuakes <- function (criticalVelocity, velocity, indices, dimensions) {
  maximumVelocities<- maxVelocity(velocity[indices,,dimensions])
  slippingTimes  <- maximumVelocities > criticalVelocity

  ns <- negativeStarts(slippingTimes) + indices[[1]] - 1
  ps <- positiveStarts(slippingTimes) + indices[[1]] - 1

  ## NOTE: we drop incomplete quakes here
  mlen <- min(length(ns), length(ps))
  ns <- ns[1:mlen]
  ps <- ps[1:mlen]

  return(data.frame(endingIndex = ns, beginningIndex = ps))
}
